diff --git a/yum/config.py b/yum/config.py
index d09511f..f0f4e96 100644
--- a/yum/config.py
+++ b/yum/config.py
@@ -697,13 +824,15 @@ class YumConf(StartupConf):
     skip_broken = BoolOption(False)
     #  Note that "instant" is the old behaviour, but group:primary is very
     # similar but better :).
-    mdpolicy = ListOption(['group:primary'])
+    mdpolicy = ListOption(['group:small'])
+    mddownloadpolicy = SelectionOption('sqlite', ('sqlite', 'xml'))
     #  ('instant', 'group:all', 'group:main', 'group:small', 'group:primary'))
-    multilib_policy = SelectionOption('all',('best', 'all'))
+    multilib_policy = SelectionOption(__main_multilib_policy_default__,
+                                      ('best', 'all'))
                  # all == install any/all arches you can
                  # best == use the 'best  arch' for the system
                  
-    bugtracker_url = Option('http://yum.baseurl.org/report')
+    bugtracker_url = Option('https://bugzilla.redhat.com/enter_bug.cgi?product=Fedora&version=rawhide&component=yum')
 
     color = SelectionOption('auto', ('auto', 'never', 'always'),
                             mapper={'on' : 'always', 'yes' : 'always',
@@ -715,22 +844,27 @@ class YumConf(StartupConf):
     color_list_installed_newer = Option('bold,yellow')
     color_list_installed_reinstall = Option('normal')
     color_list_installed_extra = Option('bold,red')
+    color_list_installed_running_kernel = Option('bold,underline')
 
     color_list_available_upgrade = Option('bold,blue')
     color_list_available_downgrade = Option('dim,cyan')
     color_list_available_reinstall = Option('bold,underline,green')
     color_list_available_install = Option('normal')
+    color_list_available_running_kernel = Option('bold,underline')
 
     color_update_installed = Option('normal')
     color_update_local     = Option('bold')
     color_update_remote    = Option('normal')
 
     color_search_match = Option('bold')
+
+    ui_repoid_vars = ListOption(['releasever', 'basearch'])
     
     sslcacert = Option()
     sslverify = BoolOption(True)
     sslclientcert = Option()
     sslclientkey = Option()
+    ssl_check_cert_permissions = BoolOption(True)
 
     history_record = BoolOption(True)
     history_record_packages = ListOption(['yum', 'rpm'])
@@ -744,18 +878,45 @@ class YumConf(StartupConf):
     
     loadts_ignoremissing = BoolOption(False)
     loadts_ignorerpm = BoolOption(False)
+    loadts_ignorenewrpm = BoolOption(False)
     
     clean_requirements_on_remove = BoolOption(False)
 
+    upgrade_requirements_on_install = BoolOption(False)
 
     history_list_view = SelectionOption('single-user-commands',
                                         ('single-user-commands', 'users',
                                          'commands'),
                                      mapper={'cmds'          : 'commands',
                                              'default' :'single-user-commands'})
+
+    recheck_installed_requires = BoolOption(False)
+
+    fssnap_automatic_pre  = BoolOption(False)
+    fssnap_automatic_post = BoolOption(False)
+    fssnap_automatic_keep = IntOption(1)
+    fssnap_percentage = IntOption(100, range_min=1, range_max=100)
+    fssnap_devices = ListOption("!*/swap !*/lv_swap "
+                                "glob:/etc/yum/fssnap.d/*.conf",
+                                parse_default=True)
+
+    depsolve_loop_limit = PositiveIntOption(100, names_of_0=["<forever>"])
+
+    autocheck_running_kernel = BoolOption(True)
+
+    check_config_file_age = BoolOption(True)
+
+    usr_w_check = BoolOption(True)
+
     _reposlist = []
 
     def dump(self):
+        """Return a string representing the values of all the
+        configuration options.
+
+        :return: a string representing the values of all the
+           configuration options
+        """
         output = '[main]\n'
         # we exclude all vars which start with _ or are in this list:
         excluded_vars = ('cfg', 'uid', 'yumvar', 'progress_obj', 'failure_obj',
@@ -778,14 +939,12 @@ class YumConf(StartupConf):
         return output
 
 class RepoConf(BaseConfig):
-    '''
-    Option definitions for repository INI file sections.
-    '''
+    """Option definitions for repository INI file sections."""
 
     __cached_keys = set()
     def iterkeys(self):
-        '''Yield the names of all defined options in the instance.
-        '''
+        """Yield the names of all defined options in the instance."""
+
         ck = self.__cached_keys
         if not isinstance(self, RepoConf):
             ck = set()
@@ -797,6 +956,7 @@ class RepoConf(BaseConfig):
 
     name = Option()
     enabled = Inherit(YumConf.enabled)
+    keepcache = Inherit(YumConf.keepcache)
     baseurl = UrlListOption()
     mirrorlist = UrlOption()
     metalink   = UrlOption()
@@ -820,42 +980,60 @@ class RepoConf(BaseConfig):
     keepalive = Inherit(YumConf.keepalive)
     enablegroups = Inherit(YumConf.enablegroups)
 
+    minrate = Inherit(YumConf.minrate)
     bandwidth = Inherit(YumConf.bandwidth)
     throttle = Inherit(YumConf.throttle)
     timeout = Inherit(YumConf.timeout)
+    ip_resolve = Inherit(YumConf.ip_resolve)
+    #  This isn't inherited so that we can automatically disable file:// _only_
+    # repos. if they haven't set an explicit deltarpm_percentage for the repo.
+    deltarpm_percentage = IntOption(None, range_min=0, range_max=100)
+    #  Rely on the above config. to do automatic disabling, and thus. no hack
+    # needed here.
+    deltarpm_metadata_percentage = Inherit(YumConf.deltarpm_metadata_percentage)
+
     http_caching = Inherit(YumConf.http_caching)
     metadata_expire = Inherit(YumConf.metadata_expire)
+    metadata_expire_filter = Inherit(YumConf.metadata_expire_filter)
     mirrorlist_expire = Inherit(YumConf.mirrorlist_expire)
     # NOTE: metalink expire _must_ be the same as metadata_expire, due to the
     #       checksumming of the repomd.xml.
     mdpolicy = Inherit(YumConf.mdpolicy)
+    mddownloadpolicy = Inherit(YumConf.mddownloadpolicy)
     cost = IntOption(1000)
     
     sslcacert = Inherit(YumConf.sslcacert)
     sslverify = Inherit(YumConf.sslverify)
     sslclientcert = Inherit(YumConf.sslclientcert)
     sslclientkey = Inherit(YumConf.sslclientkey)
+    ssl_check_cert_permissions = Inherit(YumConf.ssl_check_cert_permissions)
 
     skip_if_unavailable = BoolOption(False)
+    async = BoolOption(True)
+
+    ui_repoid_vars = Inherit(YumConf.ui_repoid_vars)
+
+    check_config_file_age = Inherit(YumConf.check_config_file_age)
+
     
 class VersionGroupConf(BaseConfig):
+    """Option definitions for version groups."""
+
     pkglist = ListOption()
     run_with_packages = BoolOption(False)
 
 
-def readStartupConfig(configfile, root):
-    '''
-    Parse Yum's main configuration file and return a StartupConf instance.
-    
-    This is required in order to access configuration settings required as Yum
-    starts up.
+def readStartupConfig(configfile, root, releasever=None):
+    """Parse Yum's main configuration file and return a
+    :class:`StartupConf` instance.  This is required in order to
+    access configuration settings required as Yum starts up.
 
-    @param configfile: The path to yum.conf.
-    @param root: The base path to use for installation (typically '/')
-    @return: A StartupConf instance.
+    :param configfile: the path to yum.conf
+    :param root: the base path to use for installation (typically '/')
+    :return: A :class:`StartupConf` instance
 
-    May raise Errors.ConfigError if a problem is detected with while parsing.
-    '''
+    :raises: :class:`Errors.ConfigError` if a problem is detected with while parsing.
+    """
 
     # ' xemacs syntax hack
 
@@ -876,20 +1054,24 @@ def readStartupConfig(configfile, root):
             raise Errors.ConfigError("All plugin search paths must be absolute")
     # Stuff this here to avoid later re-parsing
     startupconf._parser = parser
+
     # setup the release ver here
-    startupconf.releasever = _getsysver(startupconf.installroot, startupconf.distroverpkg)
+    if releasever is None:
+        releasever = _getsysver(startupconf.installroot,
+                                startupconf.distroverpkg)
+    startupconf.releasever = releasever
+
     uuidfile = '%s/%s/uuid' % (startupconf.installroot, startupconf.persistdir)
-    startupconf.uuid = get_uuid(uuidfile)
+    startupconf.uuid = get_uuid_obj(uuidfile)
 
     return startupconf
 
 def readMainConfig(startupconf):
-    '''
-    Parse Yum's main configuration file
+    """Parse Yum's main configuration file
 
-    @param startupconf: StartupConf instance as returned by readStartupConfig()
-    @return: Populated YumConf instance.
-    '''
+    :param startupconf: :class:`StartupConf` instance as returned by readStartupConfig()
+    :return: Populated :class:`YumConf` instance
+    """
     
     # ' xemacs syntax hack
 
@@ -956,6 +1138,12 @@ def readMainConfig(startupconf):
     return yumconf
 
 def readVersionGroupsConfig(configfile="/etc/yum/version-groups.conf"):
+    """Parse the configuration file for version groups.
+    
+    :param configfile: the configuration file to read
+    :return: a dictionary containing the parsed options
+    """
+
     parser = ConfigParser()
     confpp_obj = ConfigPreProcessor(configfile)
     try:
@@ -970,17 +1158,16 @@ def readVersionGroupsConfig(configfile="/etc/yum/version-groups.conf"):
 
 
 def getOption(conf, section, name, option):
-    '''Convenience function to retrieve a parsed and converted value from a
-    ConfigParser.
-
-    @param conf: ConfigParser instance or similar
-    @param section: Section name
-    @param name: Option name
-    @param option: Option instance to use for conversion.
-    @return: The parsed value or default if value was not present.
-
-    Will raise ValueError if the option could not be parsed.
-    '''
+    """Convenience function to retrieve a parsed and converted value from a
+    :class:`ConfigParser`.
+
+    :param conf: ConfigParser instance or similar
+    :param section: Section name
+    :param name: :class:`Option` name
+    :param option: :class:`Option` instance to use for conversion
+    :return: The parsed value or default if value was not present
+    :raises: :class:`ValueError` if the option could not be parsed
+    """
     try: 
         val = conf.get(section, name)
     except (NoSectionError, NoOptionError):
@@ -1010,7 +1197,10 @@ def _getsysver(installroot, distroverpkg):
     ts = rpmUtils.transaction.initReadOnlyTransaction(root=installroot)
     ts.pushVSFlags(~(rpm._RPMVSF_NOSIGNATURES|rpm._RPMVSF_NODIGESTS))
     try:
-        idx = ts.dbMatch('provides', distroverpkg)
+        for distroverpkg_prov in distroverpkg:
+            idx = ts.dbMatch('provides', distroverpkg_prov)
+            if idx.count():
+                break
     except TypeError, e:
         # This is code for "cannot open rpmdb"
         # this is for pep 352 compliance on python 2.6 and above :(
@@ -1028,25 +1218,44 @@ def _getsysver(installroot, distroverpkg):
     if idx.count() == 0:
         releasever = '$releasever'
     else:
-        hdr = idx.next()
+        try:
+            hdr = idx.next()
+        except StopIteration:
+            raise Errors.YumBaseError("Error: rpmdb failed release provides. Try: rpm --rebuilddb")
         releasever = hdr['version']
+
+        off = hdr[getattr(rpm, 'RPMTAG_PROVIDENAME')].index(distroverpkg_prov)
+        flag = hdr[getattr(rpm, 'RPMTAG_PROVIDEFLAGS')][off]
+        flag = rpmUtils.miscutils.flagToString(flag)
+        ver  = hdr[getattr(rpm, 'RPMTAG_PROVIDEVERSION')][off]
+
+        #  Note that if distroverpkg is the name of the package, then we can't
+        # use the provide because rpm automatically adds a provide for the name
+        # of the package. So just use the version, to be compatible.
+        if hdr['name'] == distroverpkg_prov:
+            flag = None
+            ver  = None
+        if flag == 'EQ' and ver:
+            # override the package version
+            releasever = ver
+
         del hdr
     del idx
     del ts
     return releasever
 
-def writeRawRepoFile(repo,only=None):
-    """
-    Writes changes in a repo object back to a .repo file.
-    @param repo: Repo Object
-    @param only: List of attributes to work on (None = All)
-    It work by reading the repo file, changes the values there shall be changed and write it back to disk.
-    """
-
+def _readRawRepoFile(repo):
     if not _use_iniparse:
-        return
+        return None
+
+    if not hasattr(repo, 'repofile') or not repo.repofile:
+        return None
+
+    try:
+        ini = INIConfig(open(repo.repofile))
+    except:
+        return None
 
-    ini = INIConfig(open(repo.repofile))
     # b/c repoids can have $values in them we need to map both ways to figure
     # out which one is which
     section_id = repo.id
@@ -1054,6 +1263,22 @@ def writeRawRepoFile(repo,only=None):
         for sect in ini._sections.keys():
             if varReplace(sect, repo.yumvar) == repo.id:
                 section_id = sect
+                break
+        else:
+            return None
+    return ini, section_id
+
+def writeRawRepoFile(repo,only=None):
+    """Write changes in a repo object back to a .repo file.
+
+    :param repo: the Repo Object to write back out
+    :param only: list of attributes to work on. If *only* is None, all
+       options will be written out   
+    """
+    if not _use_iniparse:
+        return
+
+    ini, section_id = _readRawRepoFile(repo)
     
     # Updated the ConfigParser with the changed values    
     cfgOptions = repo.cfg.options(repo.id)
@@ -1069,7 +1294,7 @@ def writeRawRepoFile(repo,only=None):
         #  If the value is the same, but just interpreted ... when we don't want
         # to keep the interpreted values.
         if (name in ini[section_id] and
-            ovalue == varReplace(ini[section_id][name], yumvar)):
+            ovalue == varReplace(ini[section_id][name], repo.yumvar)):
             ovalue = ini[section_id][name]
 
         if name not in cfgOptions and option.default == value:
@@ -1080,6 +1305,48 @@ def writeRawRepoFile(repo,only=None):
     fp.write(str(ini))
     fp.close()
 
+# Copied from yum-config-manager ... how we alter yu.conf ... used in "yum fs"
+def _writeRawConfigFile(filename, section_id, yumvar,
+                        cfgoptions, items, optionobj,
+                        only=None):
+    """
+    From writeRawRepoFile, but so we can alter [main] too.
+    """
+    ini = INIConfig(open(filename))
+
+    osection_id = section_id
+    # b/c repoids can have $values in them we need to map both ways to figure
+    # out which one is which
+    if section_id not in ini._sections:
+        for sect in ini._sections.keys():
+            if varReplace(sect, yumvar) == section_id:
+                section_id = sect
+
+    # Updated the ConfigParser with the changed values
+    cfgOptions = cfgoptions(osection_id)
+    for name,value in items():
+        if value is None: # Proxy
+            continue
+
+        if only is not None and name not in only:
+            continue
+
+        option = optionobj(name)
+        ovalue = option.tostring(value)
+        #  If the value is the same, but just interpreted ... when we don't want
+        # to keep the interpreted values.
+        if (name in ini[section_id] and
+            ovalue == varReplace(ini[section_id][name], yumvar)):
+            ovalue = ini[section_id][name]
+
+        if name not in cfgOptions and option.default == value:
+            continue
+
+        ini[section_id][name] = ovalue
+    fp =file(filename, "w")
+    fp.write(str(ini))
+    fp.close()
+
 #def main():
 #    mainconf = readMainConfig(readStartupConfig('/etc/yum/yum.conf', '/'))
 #    print mainconf.cachedir
